import java.io.*;
import java.util.*;

/*ghassan fakher
 * gkf01
 section 6*/

//**********************************************************************************************************************************************************************//
//Description:
//***this datatype is used to fill a jagged array of characters with characters from an input file***//

//			Using only scanner				//

public class JaggedArrayChar
{
	private int nbLines;	//number of lines
	private int maxLineLen;	//max line length
	private char[][] jaggedArray = new char[100][];
	
	//the constructor
	public JaggedArrayChar(String filename) throws FileNotFoundException
	{
		File inputFile = new File(filename);
		Scanner scan = new Scanner(inputFile);
		numberOfLines(scan);
		jaggedArray = new char[nbLines][];
		scan = new Scanner(inputFile);
		fillJaggedArray(scan, jaggedArray);
		findMaxLength(jaggedArray);
	}
	//counts the number of lines in the given input 
	private void numberOfLines(Scanner scan)
	{
		while(scan.hasNextLine())
		{
			scan.nextLine();
			nbLines++;
		}
	}
	//fills the jagged array with the characters from the input file
	private void fillJaggedArray(Scanner scan, char[][] jaggedArray)
	{
		for(int i = 0; i < nbLines; i++)
		{
			String line = scan.nextLine();
			jaggedArray[i] = new char[line.length()];
			for(int j = 0; j < jaggedArray[i].length; j++)
			{
				jaggedArray[i][j] = line.charAt(j);
			}
		}
	}
	//determines the max line length and assigns it to maxLineLen
	private void findMaxLength(char[][] jaggedArray)
	{
		int max = 0;
		for(int i = 0; i < jaggedArray.length; i++)
		{
			if(jaggedArray[i].length > max)
				max = jaggedArray[i].length;
		}
		maxLineLen = max;
	}
	//returns the char at the position i,j
	public char get(int i, int j)
	{
		return jaggedArray[i - 1][j - 1];	//the user doesn't know that counting starts from 0, if he wants the first char in the first line he puts (1,1) as argmuents
	}
	//returns the length of the line at i
	public int getLineLength(int i)
	{
		return jaggedArray[i - 1].length;	//the user doesn't know that java counts from 0
	}
	//returns the number of lines
	public int getNbLines()
	{
		return nbLines;
	}
	//returns the max length of lines
	public int getMaxLineLen()
	{
		return maxLineLen;
	}
	//------------------------------TESTING-----------------------------TESTING----------------------------------TESTING-----------------------------------------------//
	public static void main(String[] args) throws FileNotFoundException
	{
		JaggedArrayChar chars = new JaggedArrayChar("text.txt");
		System.out.println("the number of lines in the input file is  : " + chars.getNbLines());
		System.out.println("the max line length is : " + chars.getMaxLineLen());
		System.out.println("the third line length is " + chars.getLineLength(3));
		System.out.println("the first character at the first line is " + chars.get(1, 1));
		for(int i = 0; i < chars.getNbLines(); i++)
		{
			for(int j = 0; j < chars.getLineLength(i + 1); j++)
			{
				System.out.print(chars.get(i + 1, j + 1));
			}
			StdOut.println();
		}
	}
// /\/\/\\/\/\/\/\\/\/\/\/\/\/\/\/\/\\//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\\//\/\/\/\/\/\/\/\/\/\/\/\\\/\/\/\/\/\/\/\\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\///	
}
																			//Done//